#include    "stm32F10x.h"

void init_clock (void){
  
//**********************    PLL *************************
//******************************************************************************
	while (!(RCC->CR & RCC_CR_HSIRDY)); //   HSI
	RCC->CR |= RCC_CR_HSEON; //   HSE
	while (!(RCC->CR & RCC_CR_HSERDY)); //   HSE
	//RCC->CR|=RCC_CR_CSSON; //     HSE
	
	RCC->CFGR |= RCC_CFGR_HPRE_DIV1; // HCLK = SYSCLK  
	RCC->CFGR |= RCC_CFGR_PPRE2_DIV1; // PCLK2 = HCLK
	RCC->CFGR |= RCC_CFGR_PPRE1_DIV1; // PCLK1 = HCLK
	
	RCC->CFGR &= ~(RCC_CFGR_PLLSRC | RCC_CFGR_PLLXTPRE | RCC_CFGR_PLLMULL); // 
	RCC->CFGR |=  RCC_CFGR_PLLXTPRE; //   HSE  2 
	RCC->CFGR |= RCC_CFGR_PLLSRC_PREDIV1; //  PLL  HSE/PREDIV1
	RCC->CFGR |= RCC_CFGR_PLLMULL6; //    6
	RCC->CR |= RCC_CR_PLLON; //  PLL
	while((RCC->CR & RCC_CR_PLLRDY)==0){} //   PLL
	RCC->CFGR &=~RCC_CFGR_SW; //   SW0, SW1
	RCC->CFGR |= RCC_CFGR_SW_PLL; //    PLL
	while ((RCC->CFGR&RCC_CFGR_SWS)!=0x08); //    PLL
	RCC->APB2ENR |= RCC_APB2ENR_IOPAEN;
	RCC->APB2ENR |= RCC_APB2ENR_IOPBEN;
//******************************************************************************
//******************************************************************************
}

void init_peripherals (void){

//*********************     ****************************
//******************************************************************************     
	RCC->APB2ENR |= RCC_APB2ENR_IOPAEN; //    A
	RCC->APB2ENR |= RCC_APB2ENR_IOPBEN; //    B
	RCC->APB2ENR |= RCC_APB2ENR_IOPCEN; //    C
	RCC->APB2ENR |= RCC_APB2ENR_AFIOEN; //   .
	AFIO->MAPR |= AFIO_MAPR_SWJ_CFG_JTAGDISABLE; //  JTAG
	
#ifdef EQDRIVE
	GPIOC->CRH   |= GPIO_CRH_MODE8; //   LED4 PC8  
	GPIOC->CRH   &=~GPIO_CRH_CNF8; //     PC8
	GPIOC->CRH   |= GPIO_CRH_MODE9; //   LED3 PC9  
	GPIOC->CRH   &=~GPIO_CRH_CNF9; //    PC9
	GPIOA->CRL   &=~GPIO_CRL_MODE0; //  "USER" PA0 -  
#endif
#ifdef EQDRIVE_PRE
	GPIOA->CRH   |= GPIO_CRH_MODE8; //   LED1() PA8  
	GPIOA->CRH   &=~GPIO_CRH_CNF8; //     PA8
	GPIOB->CRH   |= GPIO_CRH_MODE15; //   LED2() PB15  
	GPIOB->CRH   &=~GPIO_CRH_CNF15; //    PB15
#endif
#ifdef EQDRIVE_PRO
	GPIOC->CRH   |= GPIO_CRH_MODE13; //   LED1() PC13  
	GPIOC->CRH   &=~GPIO_CRH_CNF13; //     PC13
	GPIOC->CRH   |= GPIO_CRH_MODE14; //   LED2() PC14  
	GPIOC->CRH   &=~GPIO_CRH_CNF14; //    PC14
#endif

//  
	//RA Port         |      REF     |      STEP     |     DIR       |      EN       |
#ifdef EQDRIVE //             |               |             |                |
	GPIOB->CRH   |=   GPIO_CRH_MODE12|GPIO_CRH_MODE13|GPIO_CRH_MODE14|GPIO_CRH_MODE15;
	GPIOB->CRH   &= ~(GPIO_CRH_CNF12|GPIO_CRH_CNF13|GPIO_CRH_CNF14|GPIO_CRH_CNF15);
#endif //                     |               |             |                |
#ifdef EQDRIVE_PRE //         |               |             |                |
	GPIOA->CRL   |=   GPIO_CRL_MODE4 |GPIO_CRL_MODE7 |GPIO_CRL_MODE6 |GPIO_CRL_MODE5;
	GPIOA->CRL   &= ~(GPIO_CRL_CNF4 |GPIO_CRL_CNF7 |GPIO_CRL_CNF6 |GPIO_CRL_CNF5);
	//                |      PW      |
	GPIOB->CRL   |=   GPIO_CRL_MODE0;
	GPIOB->CRL   &=  ~GPIO_CRL_CNF0;
#endif
#ifdef EQDRIVE_PRO
//                    |     DACAY    |       APH     |
//                            |               |
	GPIOA->CRL   |=  (GPIO_CRL_MODE6 | GPIO_CRL_MODE7);
	GPIOA->CRL   &= ~(GPIO_CRL_MODE6 | GPIO_CRL_CNF7);
//                    |      EN      |       BPH     |
//                            |               |
	GPIOB->CRL   |=   GPIO_CRL_MODE0 | GPIO_CRL_MODE1;
	GPIOB->CRL   &= ~(GPIO_CRL_CNF0  | GPIO_CRL_CNF1);
#endif
	
	//DEC Port        |      REF     |      STEP     |     DIR       |      EN       |      PW      |
#ifdef EQDRIVE //             |               |             |                |
	GPIOB->CRH   |=   GPIO_CRH_MODE8 |GPIO_CRH_MODE9 |GPIO_CRH_MODE10|GPIO_CRH_MODE11;
	GPIOB->CRH   &= ~(GPIO_CRH_CNF8  |GPIO_CRH_CNF9  |GPIO_CRH_CNF10 |GPIO_CRH_CNF11);
#endif //                     |               |             |                |               |
#ifdef EQDRIVE_PRE //         |               |             |                |               |
	GPIOB->CRH   |=   GPIO_CRH_MODE10|GPIO_CRH_MODE13|GPIO_CRH_MODE12|GPIO_CRH_MODE11|GPIO_CRH_MODE14;
	GPIOB->CRH   &= ~(GPIO_CRH_CNF10 |GPIO_CRH_CNF13 |GPIO_CRH_CNF12 |GPIO_CRH_CNF11 |GPIO_CRH_CNF14);
#endif
#ifdef EQDRIVE_PRO
//                    |     DACAY    |       APH     |      EN       |      BPH       |
//                            |               |             |                |
	GPIOB->CRH   |=                   GPIO_CRH_MODE13|GPIO_CRH_MODE14|GPIO_CRH_MODE15;
	GPIOB->CRH   &= ~(                GPIO_CRH_CNF13 |GPIO_CRH_CNF14 |GPIO_CRH_CNF15);
#endif	
//******************************************************************************
//******************************************************************************

//**********************************  ***************************************
//******************************************************************************
	GPIOA->CRL &= ~(GPIO_CRL_CNF1 | GPIO_CRL_CNF0);
	GPIOC->CRL &= ~(GPIO_CRL_MODE1 | GPIO_CRL_MODE0);
	RCC->APB2ENR |= RCC_APB2ENR_ADC1EN;	//    
	
	ADC1->CR1 |= ADC_CR1_JAUTO | ADC_CR1_SCAN;
	ADC1->CR2 	|= ADC_CR2_TSVREFE 
				|  ADC_CR2_JEXTTRIG 
				|  ADC_CR2_JEXTSEL 
				|  ADC_CR2_CONT;
	//ADC1->CR2 |= ADC_CR2_EXTSEL; //      swstart      
	//ADC1->CR2 |= ADC_CR2_EXTTRIG; //      (   )
	
	//ADC1->SMPR1 |= ADC_SMPR1_SMP16; // . -  (239.5)    16 
	//ADC1->SMPR2 |= ADC_SMPR2_SMP1 | ADC_SMPR2_SMP0; // . -  (239.5)    0  1 
	
	//ADC1->SQR1 |= ADC_SQR1_SQ1_0; //  1  (0b00001)  1  (-    1)
	//ADC1->SQR3 |= ADC_SQR3_SQ1_4; //  1  (0b00001)  1  (-    1)
	
	//ADC1->JSQR |= ADC_JSQR_JSQ1_0; //   0  1-  
	ADC1->JSQR |= ADC_JSQR_JSQ2_0; //   1  2-  
	ADC1->JSQR |= ADC_JSQR_JSQ3_4; //   16  3-  
	ADC1->JSQR |= ADC_JSQR_JSQ4_4; //   16  4-  
	ADC1->JSQR |= ADC_JSQR_JL; //    4  
	
	ADC1->CR2 |= ADC_CR2_ADON; //    
	ADC1->CR2 |= ADC_CR2_JSWSTART;
	//ADC1->CR2 |= ADC_CR2_SWSTART;
//******************************************************************************
//******************************************************************************

//*************************   SysTick ***************************
//******************************************************************************
	SysTick->LOAD = 24000;
	SysTick->CTRL |= SysTick_CTRL_CLKSOURCE; //Clock = HCLK
	//SysTick->CTRL &= ~SysTick_CTRL_CLKSOURCE; //Clock = HCLK/8
	SysTick->VAL = 0; //
	SysTick->CTRL |= SysTick_CTRL_ENABLE; //   SysTick
	NVIC_SetPriority(SysTick_IRQn, 15); //    SysTick
	SysTick->CTRL |= SysTick_CTRL_TICKINT; //   SysTick
//******************************************************************************
//******************************************************************************

//********************************  2 ***********************************
//******************************************************************************
#if (defined EQDRIVE_PRE) || (defined EQDRIVE_PRO)
	AFIO->MAPR &= ~AFIO_MAPR_TIM2_REMAP; // 
	AFIO->MAPR |= AFIO_MAPR_TIM2_REMAP; //   REMAP   2
	GPIOB->CRH |= GPIO_CRH_MODE10; //  PB.10 -  
    GPIOB->CRH &= ~GPIO_CRH_CNF10; GPIOB->CRH |=GPIO_CRH_CNF10_1; //  
#endif
#ifdef EQDRIVE_PRO
	GPIOB->CRH |= GPIO_CRH_MODE11; //  PB.11 -  
    GPIOB->CRH &= ~GPIO_CRH_CNF11; GPIOB->CRH |=GPIO_CRH_CNF11_1; //  
#endif
#if (defined EQDRIVE_PRE) || (defined EQDRIVE_PRO)
	RCC->APB1ENR |= RCC_APB1ENR_TIM2EN; //    2
	TIM2->PSC = 1 - 1; //   
	TIM2->ARR = 256 - 1; //   
	//TIM2->CCR3 = 250; //  
	//PWM
	TIM2->CR1 |= TIM_CR1_CMS_0;
	TIM2->CCMR2 |= (TIM_CCMR2_OC3M_2 | TIM_CCMR2_OC3M_1 | TIM_CCMR2_OC3PE);
	TIM2->CCER |= TIM_CCER_CC3E; //   OC3    
	TIM2->BDTR |= TIM_BDTR_MOE; //   
#endif
#ifdef EQDRIVE_PRO
	//TIM2->CCR4 = 127; //  
	TIM2->CCMR2 |= (TIM_CCMR2_OC4M_2 | TIM_CCMR2_OC4M_1 | TIM_CCMR2_OC4PE);
	TIM2->CCER |= TIM_CCER_CC4E; //   OC4    
	TIM2->BDTR |= TIM_BDTR_MOE; //   
#endif
#if (defined EQDRIVE_PRE) || (defined EQDRIVE_PRO)	
	//TIM2->DIER |= TIM_DIER_UIE | TIM_DIER_CC1IE;
	TIM2->CR1 |= (TIM_CR1_CEN | TIM_CR1_ARPE);
#endif
//******************************************************************************
//******************************************************************************
	
//********************************  3 ************************************
//******************************************************************************
	RCC->APB1ENR |= RCC_APB1ENR_TIM3EN; //    3
	TIM3->PSC = 160 - 1; //   
	TIM3->ARR = 92 - 1;
	TIM3->CCR1 = 12;
	TIM3->DIER |= TIM_DIER_UIE | TIM_DIER_CC1IE;
	TIM3->CR1 = TIM_CR1_CEN | TIM_CR1_ARPE;
	
	NVIC_SetPriority(TIM3_IRQn, 14);
	NVIC_EnableIRQ(TIM3_IRQn);
//******************************************************************************
//******************************************************************************
	
//********************************  4 ************************************
//******************************************************************************
	RCC->APB1ENR |= RCC_APB1ENR_TIM4EN; //    4
	TIM4->PSC = 160 - 1; //   
	//TIM4->ARR = (620*4) - 1;
	TIM4->ARR = 92 - 1;
	TIM4->CCR1 = 12;
	TIM4->DIER |= TIM_DIER_UIE | TIM_DIER_CC1IE;
	TIM4->CR1 = TIM_CR1_CEN | TIM_CR1_ARPE;
	
	NVIC_SetPriority(TIM4_IRQn, 13);
	NVIC_EnableIRQ(TIM4_IRQn);
//******************************************************************************
//******************************************************************************

//********************************** USART1 ************************************
//******************************************************************************
    RCC->APB2ENR |= RCC_APB2ENR_USART1EN; //   USART1
    GPIOA->CRH |= GPIO_CRH_MODE9; //  TX PA.9 -  
    GPIOA->CRH &= ~GPIO_CRH_CNF9; GPIOA->CRH |=GPIO_CRH_CNF9_1; //  
    USART1->CR1 |=(USART_CR1_RE | USART_CR1_TE); //   RX, TX
	//  9.6 kbps. USARTDIV=FSYS/(16*baud) = 24e6/(16*9600)=156.25
	USART1->BRR = (156<<4); //   156
	USART1->BRR |= 4; //  *16 = 0,25*16 = 4
	//USART1->CR1 |= USART_CR1_UE; //  USART1
	
	USART1->CR1 |= USART_CR1_RXNEIE; //   RXNE
	USART1->CR1 |= USART_CR1_TCIE; //   TC
	USART1->CR1 |= USART_CR1_UE; //  USART1
	NVIC_SetPriority(USART1_IRQn, 15); //    USART1
	//NVIC_ClearPendingIRQ (USART1_IRQn);
	NVIC_EnableIRQ(USART1_IRQn); //   USART1_IRQn  NVIC
//******************************************************************************
//******************************************************************************

//**********************************  ***************************************
//******************************************************************************
	RCC->APB1ENR |= RCC_APB1ENR_DACEN; //   DAC
	GPIOA->CRL &= ~GPIO_CRL_MODE4; //  DAC1 PA.4 -  
    GPIOA->CRL &= ~GPIO_CRL_CNF4; //    PA.4	
	DAC->CR |= DAC_CR_BOFF1; //    DAC1
	DAC->CR |= DAC_CR_TSEL1; //    DAC1
	//DAC->CR |= DAC_CR_TEN2; //   DAC1  
	DAC->CR |= DAC_CR_EN1; //  DAC1
#if (defined EQDRIVE) || (defined EQDRIVE_PRO)
	GPIOA->CRL &= ~GPIO_CRL_MODE5; //  DAC2 PA.5 -  
    GPIOA->CRL &= ~GPIO_CRL_CNF5; //    PA.5
	DAC->CR |= DAC_CR_BOFF2; //    DAC2
	DAC->CR |= DAC_CR_TSEL2; //    DAC2
	//DAC->CR |= DAC_CR_TEN1; //   DAC2  
	DAC->CR |= DAC_CR_EN2; //  DAC2
#endif
//******************************************************************************
//******************************************************************************
}
