#include    "stm32F10x.h"
#include    "stdio.h"
//#include    "mystdio.h"
#include    "eqmod.h"
#include    "init.h"
#include    "goto.h"
#include    "drive.h"

#ifdef EQDRIVE
    #define     LED3_ON		GPIOC->BSRR = GPIO_BSRR_BS9
    #define     LED3_OF		GPIOC->BSRR = GPIO_BSRR_BR9
    #define     LED3_TOGGLE	GPIOC->ODR ^= GPIO_ODR_ODR9
    #define     LED4_ON		GPIOC->BSRR = GPIO_BSRR_BS8
    #define     LED4_OF		GPIOC->BSRR = GPIO_BSRR_BR8
    #define     LED4_TOGGLE	GPIOC->ODR ^= GPIO_ODR_ODR8

    #define	REF_RA_UP	GPIOB->BSRR=GPIO_BSRR_BS12
    #define	REF_RA_DW	GPIOB->BSRR=GPIO_BSRR_BR12
    #define	STEP_RA_UP	GPIOB->BSRR=GPIO_BSRR_BS13
    #define	STEP_RA_DW	GPIOB->BSRR=GPIO_BSRR_BR13
    #define	DIR_RA_UP	GPIOB->BSRR=GPIO_BSRR_BS14
    #define	DIR_RA_DW	GPIOB->BSRR=GPIO_BSRR_BR14
    #define	EN_RA_UP	GPIOB->BSRR=GPIO_BSRR_BS15
    #define	EN_RA_DW	GPIOB->BSRR=GPIO_BSRR_BR15

    #define	REF_DEC_UP	GPIOB->BSRR=GPIO_BSRR_BS8
    #define	REF_DEC_DW	GPIOB->BSRR=GPIO_BSRR_BR8
    #define	STEP_DEC_UP	GPIOB->BSRR=GPIO_BSRR_BS9
    #define	STEP_DEC_DW	GPIOB->BSRR=GPIO_BSRR_BR9
    #define	DIR_DEC_UP	GPIOB->BSRR=GPIO_BSRR_BS10
    #define	DIR_DEC_DW	GPIOB->BSRR=GPIO_BSRR_BR10
    #define	EN_DEC_UP	GPIOB->BSRR=GPIO_BSRR_BS11
    #define	EN_DEC_DW	GPIOB->BSRR=GPIO_BSRR_BR11
#endif

#ifdef EQDRIVE_PRE
	#define     LED4_ON		GPIOA->BSRR = GPIO_BSRR_BS8
	#define     LED4_OF		GPIOA->BSRR = GPIO_BSRR_BR8
	#define     LED4_TOGGLE	GPIOA->ODR ^= GPIO_ODR_ODR8
	#define     LED3_ON		GPIOB->BSRR = GPIO_BSRR_BS15
	#define     LED3_OF		GPIOB->BSRR = GPIO_BSRR_BR15
	#define     LED3_TOGGLE	GPIOB->ODR ^= GPIO_ODR_ODR15

	#define	REF_RA_UP		GPIOA->BSRR=GPIO_BSRR_BS4
	#define	REF_RA_DW		GPIOA->BSRR=GPIO_BSRR_BR4
	#define	STEP_RA_UP		GPIOA->BSRR=GPIO_BSRR_BS7
	#define	STEP_RA_DW		GPIOA->BSRR=GPIO_BSRR_BR7

#ifdef REVERSE_RA
	#define	DIR_RA_UP		GPIOA->BSRR=GPIO_BSRR_BR6
	#define	DIR_RA_DW		GPIOA->BSRR=GPIO_BSRR_BS6
#else
	#define	DIR_RA_UP		GPIOA->BSRR=GPIO_BSRR_BS6
	#define	DIR_RA_DW		GPIOA->BSRR=GPIO_BSRR_BR6
#endif

	#define	EN_RA_UP		GPIOA->BSRR=GPIO_BSRR_BS5
	#define	EN_RA_DW		GPIOA->BSRR=GPIO_BSRR_BR5
	#define	PW_RA_UP		GPIOB->BSRR=GPIO_BSRR_BS0
	#define	PW_RA_DW		GPIOB->BSRR=GPIO_BSRR_BR0

	#define	REF_DEC_UP		GPIOB->BSRR=GPIO_BSRR_BS10
	#define	REF_DEC_DW		GPIOB->BSRR=GPIO_BSRR_BR10
	#define	STEP_DEC_UP		GPIOB->BSRR=GPIO_BSRR_BS13
	#define	STEP_DEC_DW		GPIOB->BSRR=GPIO_BSRR_BR13

#ifdef REVERSE_DEC
	#define	DIR_DEC_UP		GPIOB->BSRR=GPIO_BSRR_BR12
	#define	DIR_DEC_DW		GPIOB->BSRR=GPIO_BSRR_BS12
#else
	#define	DIR_DEC_UP		GPIOB->BSRR=GPIO_BSRR_BS12
	#define	DIR_DEC_DW		GPIOB->BSRR=GPIO_BSRR_BR12
#endif

	#define	EN_DEC_UP		GPIOB->BSRR=GPIO_BSRR_BS11
	#define	EN_DEC_DW		GPIOB->BSRR=GPIO_BSRR_BR11
	#define	PW_DEC_UP		GPIOB->BSRR=GPIO_BSRR_BS14
	#define	PW_DEC_DW		GPIOB->BSRR=GPIO_BSRR_BR14
#endif

#ifdef EQDRIVE_PRO
	#define     LED4_ON		GPIOC->BSRR = GPIO_BSRR_BS14
	#define     LED4_OF		GPIOC->BSRR = GPIO_BSRR_BR14
	#define     LED4_TOGGLE	GPIOC->ODR ^= GPIO_ODR_ODR14
	#define     LED3_ON		GPIOC->BSRR = GPIO_BSRR_BS13
	#define     LED3_OF		GPIOC->BSRR = GPIO_BSRR_BR13
	#define     LED3_TOGGLE	GPIOC->ODR ^= GPIO_ODR_ODR13
	//RA
	#define	DACAY_RA_UP		GPIOA->BSRR=GPIO_BSRR_BS6
	#define	DACAY_RA_DW		GPIOA->BSRR=GPIO_BSRR_BR6
	#define	APH_RA_UP		GPIOA->BSRR=GPIO_BSRR_BS7
	#define	APH_RA_DW		GPIOA->BSRR=GPIO_BSRR_BR7
	#define	BPH_RA_UP		GPIOB->BSRR=GPIO_BSRR_BS1
	#define	BPH_RA_DW		GPIOB->BSRR=GPIO_BSRR_BR1
	#define	EN_RA_UP		GPIOB->BSRR=GPIO_BSRR_BR0
	#define	EN_RA_DW		GPIOB->BSRR=GPIO_BSRR_BS0
	#define AVREF_RA	DAC->DHR12R1
	#define BVREF_RA	DAC->DHR12R2
	//DEC
	#define	DACAY_DEC_UP	GPIOB->BSRR=GPIO_BSRR_BS12
	#define	DACAY_DEC_DW	GPIOB->BSRR=GPIO_BSRR_BR12
	#define	APH_DEC_UP		GPIOB->BSRR=GPIO_BSRR_BS13
	#define	APH_DEC_DW		GPIOB->BSRR=GPIO_BSRR_BR13
	#define	BPH_DEC_UP		GPIOB->BSRR=GPIO_BSRR_BS15
	#define	BPH_DEC_DW		GPIOB->BSRR=GPIO_BSRR_BR15
	#define	EN_DEC_UP		GPIOB->BSRR=GPIO_BSRR_BR14
	#define	EN_DEC_DW		GPIOB->BSRR=GPIO_BSRR_BS14
	#define AVREF_DEC	TIM2->CCR3
	#define BVREF_DEC	TIM2->CCR4
#endif

//#define TIMER_RA	TIM4->PSC
//#define TIMER_DEC	TIM3->PSC
#define TIMER_RA	TIM4
#define TIMER_DEC	TIM3

extern u32 SysTickTime;
extern u8 TxBuffer[10], TxCounter;
